Scriptname StashCapsMonitor extends ReferenceAlias

MiscObject Property Caps001 Auto Const
MiscObject Property CapCurrency Auto Const
MiscObject Property CapDUMMY Auto Const

Event OnInit()
	SyncCurToCaps()
	SetFilters()
	RegisterForMenuOpenCloseEvent("BarterMenu")
EndEvent

Event Actor.OnPlayerLoadGame(Actor akSender)
	SyncCurToCaps()
	SetFilters()
	RegisterForMenuOpenCloseEvent("BarterMenu")
EndEvent

Event OnItemAdded(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akSourceContainer)
	SyncCaps(akBaseItem)
EndEvent

Event OnItemRemoved(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akSourceContainer)
	SyncCaps(akBaseItem)
EndEvent

; Prevent currency from making an appearance in trading screens

Event OnMenuOpenCloseEvent(string asMenuName, bool abOpening)
	Actor PlayerRef = Game.GetPlayer()
	Int CCaps
	
	RemoveFilters()
	if abOpening
		RemoveAllItems(CapCurrency)
	else
		SyncCurToCaps()
	endif
	SetFilters()
EndEvent

Function SyncCaps(Form akBaseItem)
	if akBaseItem == Caps001
		SyncCurToCaps()
	elseif akBaseItem == CapCurrency
		SyncCapsToCur()
	endif
endFunction

; Set Currency 

Function SyncCurToCaps()
	Actor PlayerRef = Game.GetPlayer()	
	Int CCaps
			
	CCaps = PlayerRef.GetItemCount(Caps001)
	RemoveAllItems(CapCurrency)
	AddLongItems(CapCurrency, CCaps)
EndFunction

; Set Caps

Function SyncCapsToCur()
	Actor PlayerRef = Game.GetPlayer()
	Int CCaps

	CCaps = PlayerRef.GetItemCount(CapCurrency)
	RemoveAllItems(Caps001)
	AddLongItems(Caps001, CCaps)	
EndFunction

Function AddLongItems(MiscObject Cur, Int CCaps)
	Actor PlayerRef = Game.GetPlayer()
	RemoveFilters()
	
	while CCaps > 32767
		CCaps = CCaps - 32767
		PlayerRef.additem(Cur, 32767, true)
	endwhile
	
	PlayerRef.additem(Cur, CCaps, true)
	SetFilters()
endFunction

Function RemoveLongItems(MiscObject Cur, Int CCaps)
	Actor PlayerRef = Game.GetPlayer()
	RemoveFilters()
	
	while CCaps > 32767
		CCaps = CCaps - 32767
		PlayerRef.removeitem(Cur, 32767, true)
	endwhile
	
	PlayerRef.removeitem(Cur, CCaps, true)
	SetFilters()
endFunction

Function RemoveAllItems(MiscObject Cur)
	Actor PlayerRef = Game.GetPlayer()
	RemoveFilters()
	PlayerRef.removeitem(Cur, 999999999, true)
	SetFilters()
endFunction

Function SetFilters()
	RemoveAllInventoryEventFilters()
	AddInventoryEventFilter(Caps001) 
	AddInventoryEventFilter(CapCurrency)
endFunction

Function RemoveFilters()
	RemoveAllInventoryEventFilters()
	AddInventoryEventFilter(CapDUMMY)
endFunction

